---
title: List All Tunnels
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api)

[Zero Trust](https://developers.cloudflare.com/api/resources/zero_trust)

[Tunnels](https://developers.cloudflare.com/api/resources/zero_trust/subresources/tunnels)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# List All Tunnels

GET/accounts/{account\_id}/tunnels

Lists and filters all types of Tunnels in an account.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Cloudflare One Connectors Write``Cloudflare One Connectors Read``Cloudflare One Connector: cloudflared Write``Cloudflare One Connector: cloudflared Read``Cloudflare Tunnel Write``Cloudflare Tunnel Read`

##### P ath ParametersExpand Collapse

account\_id: string

Cloudflare account ID

maxLength32

[Link to this property](<#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20account_id%20%3E%20(schema)>)

##### Q uery ParametersExpand Collapse

exclude\_prefix: optional string

[Link to this property](<#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20exclude_prefix%20%3E%20(schema)>)

existed\_at: optional string

If provided, include only resources that were created (and not deleted) before this time. URL encoded.

formaturl-encoded-date-time

[Link to this property](<#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20existed_at%20%3E%20(schema)>)

include\_prefix: optional string

[Link to this property](<#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20include_prefix%20%3E%20(schema)>)

is\_deleted: optional boolean

If `true`, only include deleted tunnels. If `false`, exclude deleted tunnels. If empty, all tunnels will be included.

[Link to this property](<#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20is_deleted%20%3E%20(schema)>)

name: optional string

A user-friendly name for the tunnel.

[Link to this property](<#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20name%20%3E%20(schema)>)

page: optional number

Page number of paginated results.

minimum1

[Link to this property](<#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20page%20%3E%20(schema)>)

per\_page: optional number

Number of results to display.

maximum1000

minimum1

[Link to this property](<#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20per_page%20%3E%20(schema)>)

<details>

<summary>

status: optional "inactive"or "degraded"or "healthy"or "down"

The status of the tunnel. Valid values are <code>inactive</code> (tunnel has never been run), <code>degraded</code> (tunnel is active and able to serve traffic but in an unhealthy state), <code>healthy</code> (tunnel is active and able to serve traffic), or <code>down</code> (tunnel can not serve traffic as it has no connections to the Cloudflare Edge).

</summary>

One of the following:

"inactive"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20status%20%3E%20(schema)%20%3E%20(member)%200">Link to this property</a>

"degraded"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20status%20%3E%20(schema)%20%3E%20(member)%201">Link to this property</a>

"healthy"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20status%20%3E%20(schema)%20%3E%20(member)%202">Link to this property</a>

"down"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20status%20%3E%20(schema)%20%3E%20(member)%203">Link to this property</a>

</details>

[Link to this property](<#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20status%20%3E%20(schema)>)

<details>

<summary>

tun\_types: optional array of "cfd\_tunnel"or "warp\_connector"or "warp"or 4 more

The types of tunnels to filter by, separated by commas.

</summary>

One of the following:

"cfd\_tunnel"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20tun_types%20%3E%20(schema)%20%3E%20(items)%20%3E%20(member)%200">Link to this property</a>

"warp\_connector"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20tun_types%20%3E%20(schema)%20%3E%20(items)%20%3E%20(member)%201">Link to this property</a>

"warp"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20tun_types%20%3E%20(schema)%20%3E%20(items)%20%3E%20(member)%202">Link to this property</a>

"magic"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20tun_types%20%3E%20(schema)%20%3E%20(items)%20%3E%20(member)%203">Link to this property</a>

"ip\_sec"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20tun_types%20%3E%20(schema)%20%3E%20(items)%20%3E%20(member)%204">Link to this property</a>

"gre"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20tun_types%20%3E%20(schema)%20%3E%20(items)%20%3E%20(member)%205">Link to this property</a>

"cni"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20tun_types%20%3E%20(schema)%20%3E%20(items)%20%3E%20(member)%206">Link to this property</a>

</details>

[Link to this property](<#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20tun_types%20%3E%20(schema)>)

uuid: optional string

UUID of the tunnel.

formatuuid

maxLength36

[Link to this property](<#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20uuid%20%3E%20(schema)>)

was\_active\_at: optional string

formatdate-time

[Link to this property](<#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20was_active_at%20%3E%20(schema)>)

was\_inactive\_at: optional string

formatdate-time

[Link to this property](<#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(params)%20default%20%3E%20(param)%20was_inactive_at%20%3E%20(schema)>)

##### ReturnsExpand Collapse

<details>

<summary>

errors: array of <a href="https://developers.cloudflare.com/api/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20response_info%20%3E%20(schema)">ResponseInfo</a> { code, message, documentation\_url, source }

</summary>

code: number

minimum1000

<a href="#(resource)%20%24shared%20%3E%20(model)%20response_info%20%3E%20(schema)%20%3E%20(property)%20code">Link to this property</a>

message: string

<a href="#(resource)%20%24shared%20%3E%20(model)%20response_info%20%3E%20(schema)%20%3E%20(property)%20message">Link to this property</a>

documentation\_url: optional string

<a href="#(resource)%20%24shared%20%3E%20(model)%20response_info%20%3E%20(schema)%20%3E%20(property)%20documentation_url">Link to this property</a>

<details>

<summary>

source: optional object {pointer }

</summary>

pointer: optional string

<a href="#(resource)%20%24shared%20%3E%20(model)%20response_info%20%3E%20(schema)%20%3E%20(property)%20source%20%3E%20(property)%20pointer">Link to this property</a>

</details>

<a href="#(resource)%20%24shared%20%3E%20(model)%20response_info%20%3E%20(schema)%20%3E%20(property)%20source">Link to this property</a>

</details>

[Link to this property](<#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(network%20schema)%20%3E%20(property)%20errors>)

<details>

<summary>

messages: array of <a href="https://developers.cloudflare.com/api/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20response_info%20%3E%20(schema)">ResponseInfo</a> { code, message, documentation\_url, source }

</summary>

code: number

minimum1000

<a href="#(resource)%20%24shared%20%3E%20(model)%20response_info%20%3E%20(schema)%20%3E%20(property)%20code">Link to this property</a>

message: string

<a href="#(resource)%20%24shared%20%3E%20(model)%20response_info%20%3E%20(schema)%20%3E%20(property)%20message">Link to this property</a>

documentation\_url: optional string

<a href="#(resource)%20%24shared%20%3E%20(model)%20response_info%20%3E%20(schema)%20%3E%20(property)%20documentation_url">Link to this property</a>

<details>

<summary>

source: optional object {pointer }

</summary>

pointer: optional string

<a href="#(resource)%20%24shared%20%3E%20(model)%20response_info%20%3E%20(schema)%20%3E%20(property)%20source%20%3E%20(property)%20pointer">Link to this property</a>

</details>

<a href="#(resource)%20%24shared%20%3E%20(model)%20response_info%20%3E%20(schema)%20%3E%20(property)%20source">Link to this property</a>

</details>

[Link to this property](<#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(network%20schema)%20%3E%20(property)%20messages>)

<details>

<summary>

result: array of <a href="https://developers.cloudflare.com/api/resources/$shared#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)">CloudflareTunnel</a> { id, account\_tag, config\_src, 10 more } or object {id, account\_tag, connections, 8 more }

</summary>

One of the following:

<details>

<summary>

CloudflareTunnel object {id, account\_tag, config\_src, 10 more }

A Cloudflare Tunnel that connects your origin to Cloudflare’s edge.

</summary>

id: optional string

UUID of the tunnel.

formatuuid

maxLength36

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

account\_tag: optional string

Cloudflare account ID

maxLength32

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20account_tag">Link to this property</a>

<details>

<summary>

config\_src: optional "local"or "cloudflare"

Indicates if this is a locally or remotely configured tunnel. If <code>local</code>, manage the tunnel using a YAML file on the origin machine. If <code>cloudflare</code>, manage the tunnel on the Zero Trust dashboard.

</summary>

One of the following:

"local"

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20config_src%20%3E%20(member)%200">Link to this property</a>

"cloudflare"

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20config_src%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20config_src">Link to this property</a>

<details>

<summary>

Deprecatedconnections: optional array of object {id, client\_id, client\_version, 5 more }

This field will start returning an empty array. To fetch the connections of a given tunnel, please use the dedicated endpoint <code>/accounts/{account_id}/{tunnel_type}/{tunnel_id}/connections</code>

The Cloudflare Tunnel connections between your origin and Cloudflare’s edge.

</summary>

id: optional string

UUID of the Cloudflare Tunnel connection.

formatuuid

maxLength36

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20connections%20%3E%20(items)%20%3E%20(property)%20id">Link to this property</a>

client\_id: optional string

UUID of the Cloudflare Tunnel connector.

formatuuid

maxLength36

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20connections%20%3E%20(items)%20%3E%20(property)%20client_id">Link to this property</a>

client\_version: optional string

The cloudflared version used to establish this connection.

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20connections%20%3E%20(items)%20%3E%20(property)%20client_version">Link to this property</a>

colo\_name: optional string

The Cloudflare data center used for this connection.

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20connections%20%3E%20(items)%20%3E%20(property)%20colo_name">Link to this property</a>

Deprecatedis\_pending\_reconnect: optional boolean

This functionality has been removed. The is\_pending\_reconnect field will now always report false.

Cloudflare continues to track connections for several minutes after they disconnect. This is an optimization to improve latency and reliability of reconnecting. If <code>true</code>, the connection has disconnected but is still being tracked. If <code>false</code>, the connection is actively serving traffic.

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20connections%20%3E%20(items)%20%3E%20(property)%20is_pending_reconnect">Link to this property</a>

opened\_at: optional string

Timestamp of when the connection was established.

formatdate-time

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20connections%20%3E%20(items)%20%3E%20(property)%20opened_at">Link to this property</a>

origin\_ip: optional string

The public IP address of the host running cloudflared.

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20connections%20%3E%20(items)%20%3E%20(property)%20origin_ip">Link to this property</a>

uuid: optional string

UUID of the Cloudflare Tunnel connection.

formatuuid

maxLength36

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20connections%20%3E%20(items)%20%3E%20(property)%20uuid">Link to this property</a>

</details>

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20connections">Link to this property</a>

conns\_active\_at: optional string

Timestamp of when the tunnel established at least one connection to Cloudflare’s edge. If <code>null</code>, the tunnel is inactive.

formatdate-time

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20conns_active_at">Link to this property</a>

conns\_inactive\_at: optional string

Timestamp of when the tunnel became inactive (no connections to Cloudflare’s edge). If <code>null</code>, the tunnel is active.

formatdate-time

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20conns_inactive_at">Link to this property</a>

created\_at: optional string

Timestamp of when the resource was created.

formatdate-time

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20created_at">Link to this property</a>

deleted\_at: optional string

Timestamp of when the resource was deleted. If <code>null</code>, the resource has not been deleted.

formatdate-time

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20deleted_at">Link to this property</a>

metadata: optional unknown

Metadata associated with the tunnel.

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20metadata">Link to this property</a>

name: optional string

A user-friendly name for a tunnel.

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20name">Link to this property</a>

Deprecatedremote\_config: optional boolean

Use the config\_src field instead.

If <code>true</code>, the tunnel can be configured remotely from the Zero Trust dashboard. If <code>false</code>, the tunnel must be configured locally on the origin machine.

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20remote_config">Link to this property</a>

<details>

<summary>

status: optional "inactive"or "degraded"or "healthy"or "down"

The status of the tunnel. Valid values are <code>inactive</code> (tunnel has never been run), <code>degraded</code> (tunnel is active and able to serve traffic but in an unhealthy state), <code>healthy</code> (tunnel is active and able to serve traffic), or <code>down</code> (tunnel can not serve traffic as it has no connections to the Cloudflare Edge).

</summary>

One of the following:

"inactive"

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%200">Link to this property</a>

"degraded"

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%201">Link to this property</a>

"healthy"

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%202">Link to this property</a>

"down"

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20status%20%3E%20(member)%203">Link to this property</a>

</details>

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20status">Link to this property</a>

<details>

<summary>

tun\_type: optional "cfd\_tunnel"or "warp\_connector"or "warp"or 4 more

The type of tunnel.

</summary>

One of the following:

"cfd\_tunnel"

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20tun_type%20%3E%20(member)%200">Link to this property</a>

"warp\_connector"

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20tun_type%20%3E%20(member)%201">Link to this property</a>

"warp"

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20tun_type%20%3E%20(member)%202">Link to this property</a>

"magic"

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20tun_type%20%3E%20(member)%203">Link to this property</a>

"ip\_sec"

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20tun_type%20%3E%20(member)%204">Link to this property</a>

"gre"

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20tun_type%20%3E%20(member)%205">Link to this property</a>

"cni"

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20tun_type%20%3E%20(member)%206">Link to this property</a>

</details>

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)%20%3E%20(property)%20tun_type">Link to this property</a>

</details>

<a href="#(resource)%20%24shared%20%3E%20(model)%20cloudflare_tunnel%20%3E%20(schema)">Link to this property</a>

<details>

<summary>

TunnelWARPConnectorTunnel object {id, account\_tag, connections, 8 more }

A Mesh node that connects your origin to Cloudflare’s edge.

</summary>

id: optional string

UUID of the tunnel.

formatuuid

maxLength36

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20id">Link to this property</a>

account\_tag: optional string

Cloudflare account ID

maxLength32

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20account_tag">Link to this property</a>

<details>

<summary>

Deprecatedconnections: optional array of object {id, client\_id, client\_version, 5 more }

This field will start returning an empty array. To fetch the connections of a given tunnel, please use the dedicated endpoint <code>/accounts/{account_id}/{tunnel_type}/{tunnel_id}/connections</code>

The Cloudflare Tunnel connections between your origin and Cloudflare’s edge.

</summary>

id: optional string

UUID of the Cloudflare Tunnel connection.

formatuuid

maxLength36

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20connections%20%3E%20(items)%20%3E%20(property)%20id">Link to this property</a>

client\_id: optional string

UUID of the Cloudflare Tunnel connector.

formatuuid

maxLength36

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20connections%20%3E%20(items)%20%3E%20(property)%20client_id">Link to this property</a>

client\_version: optional string

The cloudflared version used to establish this connection.

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20connections%20%3E%20(items)%20%3E%20(property)%20client_version">Link to this property</a>

colo\_name: optional string

The Cloudflare data center used for this connection.

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20connections%20%3E%20(items)%20%3E%20(property)%20colo_name">Link to this property</a>

Deprecatedis\_pending\_reconnect: optional boolean

This functionality has been removed. The is\_pending\_reconnect field will now always report false.

Cloudflare continues to track connections for several minutes after they disconnect. This is an optimization to improve latency and reliability of reconnecting. If <code>true</code>, the connection has disconnected but is still being tracked. If <code>false</code>, the connection is actively serving traffic.

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20connections%20%3E%20(items)%20%3E%20(property)%20is_pending_reconnect">Link to this property</a>

opened\_at: optional string

Timestamp of when the connection was established.

formatdate-time

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20connections%20%3E%20(items)%20%3E%20(property)%20opened_at">Link to this property</a>

origin\_ip: optional string

The public IP address of the host running cloudflared.

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20connections%20%3E%20(items)%20%3E%20(property)%20origin_ip">Link to this property</a>

uuid: optional string

UUID of the Cloudflare Tunnel connection.

formatuuid

maxLength36

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20connections%20%3E%20(items)%20%3E%20(property)%20uuid">Link to this property</a>

</details>

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20connections">Link to this property</a>

conns\_active\_at: optional string

Timestamp of when the tunnel established at least one connection to Cloudflare’s edge. If <code>null</code>, the tunnel is inactive.

formatdate-time

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20conns_active_at">Link to this property</a>

conns\_inactive\_at: optional string

Timestamp of when the tunnel became inactive (no connections to Cloudflare’s edge). If <code>null</code>, the tunnel is active.

formatdate-time

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20conns_inactive_at">Link to this property</a>

created\_at: optional string

Timestamp of when the resource was created.

formatdate-time

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20created_at">Link to this property</a>

deleted\_at: optional string

Timestamp of when the resource was deleted. If <code>null</code>, the resource has not been deleted.

formatdate-time

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20deleted_at">Link to this property</a>

metadata: optional unknown

Metadata associated with the tunnel.

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20metadata">Link to this property</a>

name: optional string

A user-friendly name for a tunnel.

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20name">Link to this property</a>

<details>

<summary>

status: optional "inactive"or "degraded"or "healthy"or "down"

The status of the tunnel. Valid values are <code>inactive</code> (tunnel has never been run), <code>degraded</code> (tunnel is active and able to serve traffic but in an unhealthy state), <code>healthy</code> (tunnel is active and able to serve traffic), or <code>down</code> (tunnel can not serve traffic as it has no connections to the Cloudflare Edge).

</summary>

One of the following:

"inactive"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20status%20%3E%20(member)%200">Link to this property</a>

"degraded"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20status%20%3E%20(member)%201">Link to this property</a>

"healthy"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20status%20%3E%20(member)%202">Link to this property</a>

"down"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20status%20%3E%20(member)%203">Link to this property</a>

</details>

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20status">Link to this property</a>

<details>

<summary>

tun\_type: optional "cfd\_tunnel"or "warp\_connector"or "warp"or 4 more

The type of tunnel.

</summary>

One of the following:

"cfd\_tunnel"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20tun_type%20%3E%20(member)%200">Link to this property</a>

"warp\_connector"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20tun_type%20%3E%20(member)%201">Link to this property</a>

"warp"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20tun_type%20%3E%20(member)%202">Link to this property</a>

"magic"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20tun_type%20%3E%20(member)%203">Link to this property</a>

"ip\_sec"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20tun_type%20%3E%20(member)%204">Link to this property</a>

"gre"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20tun_type%20%3E%20(member)%205">Link to this property</a>

"cni"

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20tun_type%20%3E%20(member)%206">Link to this property</a>

</details>

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201%20%3E%20(property)%20tun_type">Link to this property</a>

</details>

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(model)%20tunnel_list_response%20%3E%20(schema)%20%3E%20(variant)%201">Link to this property</a>

</details>

[Link to this property](<#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(network%20schema)%20%3E%20(property)%20result>)

success: true

Whether the API call was successful

[Link to this property](<#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(network%20schema)%20%3E%20(property)%20success>)

<details>

<summary>

result\_info: optional object {count, page, per\_page, total\_count }

</summary>

count: optional number

Total number of results for the requested service

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(network%20schema)%20%3E%20(property)%20result_info%20%3E%20(property)%20count">Link to this property</a>

page: optional number

Current page within paginated list of results

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(network%20schema)%20%3E%20(property)%20result_info%20%3E%20(property)%20page">Link to this property</a>

per\_page: optional number

Number of results per page of results

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(network%20schema)%20%3E%20(property)%20result_info%20%3E%20(property)%20per_page">Link to this property</a>

total\_count: optional number

Total results available without any search parameters

<a href="#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(network%20schema)%20%3E%20(property)%20result_info%20%3E%20(property)%20total_count">Link to this property</a>

</details>

[Link to this property](<#(resource)%20zero_trust.tunnels%20%3E%20(method)%20list%20%3E%20(network%20schema)%20%3E%20(property)%20result_info>)

### List All Tunnels

HTTP

HTTPTypeScriptPythonGoTerraform

```
curl https://api.cloudflare.com/client/v4/accounts/$ACCOUNT_ID/tunnels \
    -H "Authorization: Bearer $CLOUDFLARE_API_TOKEN"
```

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": [
    {
      "id": "f70ff985-a4ef-4643-bbbc-4a0ed4fc8415",
      "account_tag": "699d98642c564d2e855e9661899b7252",
      "config_src": "cloudflare",
      "connections": [
        {
          "id": "1bedc50d-42b3-473c-b108-ff3d10c0d925",
          "client_id": "1bedc50d-42b3-473c-b108-ff3d10c0d925",
          "client_version": "2022.7.1",
          "colo_name": "DFW",
          "is_pending_reconnect": false,
          "opened_at": "2021-01-25T18:22:34.317854Z",
          "origin_ip": "10.1.0.137",
          "uuid": "1bedc50d-42b3-473c-b108-ff3d10c0d925"
        }
      ],
      "conns_active_at": "2009-11-10T23:00:00Z",
      "conns_inactive_at": "2009-11-10T23:00:00Z",
      "created_at": "2021-01-25T18:22:34.317854Z",
      "deleted_at": "2009-11-10T23:00:00Z",
      "metadata": {},
      "name": "blog",
      "remote_config": true,
      "status": "healthy",
      "tun_type": "cfd_tunnel"
    }
  ],
  "success": true,
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000
  }
}
```

##### Returns Examples

200 example

```
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": [
    {
      "id": "f70ff985-a4ef-4643-bbbc-4a0ed4fc8415",
      "account_tag": "699d98642c564d2e855e9661899b7252",
      "config_src": "cloudflare",
      "connections": [
        {
          "id": "1bedc50d-42b3-473c-b108-ff3d10c0d925",
          "client_id": "1bedc50d-42b3-473c-b108-ff3d10c0d925",
          "client_version": "2022.7.1",
          "colo_name": "DFW",
          "is_pending_reconnect": false,
          "opened_at": "2021-01-25T18:22:34.317854Z",
          "origin_ip": "10.1.0.137",
          "uuid": "1bedc50d-42b3-473c-b108-ff3d10c0d925"
        }
      ],
      "conns_active_at": "2009-11-10T23:00:00Z",
      "conns_inactive_at": "2009-11-10T23:00:00Z",
      "created_at": "2021-01-25T18:22:34.317854Z",
      "deleted_at": "2009-11-10T23:00:00Z",
      "metadata": {},
      "name": "blog",
      "remote_config": true,
      "status": "healthy",
      "tun_type": "cfd_tunnel"
    }
  ],
  "success": true,
  "result_info": {
    "count": 1,
    "page": 1,
    "per_page": 20,
    "total_count": 2000
  }
}
```